unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVScroll, RichView, RVEdit, ComCtrls, ToolWin, RVStyle, MyRVStyle;

type
  TForm1 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    ToolBar1: TToolBar;
    btnBold: TToolButton;
    btnItalic: TToolButton;
    btnShadow: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    procedure RichViewEdit1StyleConversion(Sender: TCustomRichViewEdit;
      StyleNo, UserData: Integer; AppliedToText: Boolean;
      var NewStyleNo: Integer);
    procedure FormCreate(Sender: TObject);
    procedure btnBoldClick(Sender: TObject);
    procedure btnItalicClick(Sender: TObject);
    procedure btnShadowClick(Sender: TObject);
    procedure RichViewEdit1CurTextStyleChanged(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
  private
    { Private declarations }
    RVStyle1: TMyRVStyle;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

const
  TEXT_BOLD = 1;
  TEXT_ITALIC = 2;
  TEXT_SHADOW = 3;

{$R *.dfm}

procedure TForm1.RichViewEdit1StyleConversion(Sender: TCustomRichViewEdit;
  StyleNo, UserData: Integer; AppliedToText: Boolean;
  var NewStyleNo: Integer);
var FontInfo: TMyFontInfo;
begin
  FontInfo := TMyFontInfo.Create(nil);
  try
    FontInfo.Assign(RVStyle1.TextStyles[StyleNo]);
    case UserData of
      TEXT_BOLD:
        if btnBold.Down then
          FontInfo.Style := FontInfo.Style+[fsBold]
        else
          FontInfo.Style := FontInfo.Style-[fsBold];
      TEXT_ITALIC:
        if btnItalic.Down then
          FontInfo.Style := FontInfo.Style+[fsItalic]
        else
          FontInfo.Style := FontInfo.Style-[fsItalic];
      TEXT_SHADOW:
        FontInfo.Shadow := btnShadow.Down;
    end;
    NewStyleNo := RVStyle1.TextStyles.FindSuchStyle(StyleNo,FontInfo,
      RVAllFontInfoProperties);
    if NewStyleNo=-1 then begin
      RVStyle1.TextStyles.Add;
      NewStyleNo := RVStyle1.TextStyles.Count-1;
      RVStyle1.TextStyles[NewStyleNo].Assign(FontInfo);
      RVStyle1.TextStyles[NewStyleNo].Standard := False;
    end;
  finally
    FontInfo.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RVStyle1 := TMyRVStyle.Create(Self);
  RichViewEdit1.Style := RVStyle1;
  RichViewEdit1.RTFReadProperties.StyleComparer := TMyRTFStyleComparer.Create;
end;

procedure TForm1.btnBoldClick(Sender: TObject);
begin
  RichViewEdit1.ApplyStyleConversion(TEXT_BOLD);
end;

procedure TForm1.btnItalicClick(Sender: TObject);
begin
  RichViewEdit1.ApplyStyleConversion(TEXT_ITALIC);
end;

procedure TForm1.btnShadowClick(Sender: TObject);
begin
  RichViewEdit1.ApplyStyleConversion(TEXT_SHADOW);
end;

procedure TForm1.RichViewEdit1CurTextStyleChanged(Sender: TObject);
var FontInfo: TMyFontInfo;
begin
  FontInfo := RVStyle1.TextStyles[RichViewEdit1.CurTextStyleNo] as TMyFontInfo;
  btnBold.Down   := fsBold      in FontInfo.Style;
  btnItalic.Down := fsItalic    in FontInfo.Style;
  btnShadow.Down := FontInfo.Shadow;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  RichViewEdit1.SaveHTMLEx( '1.html', 'Shadow Test', 'img', '', '', '', []);
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  RichViewEdit1.SaveRTF('1.rtf', False);
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  RichViewEdit1.PasteRTF;
end;

end.
